#pragma once
#include <AnalogCard.hpp>
class AnalogIoT {
    public:
        bool begin(AnalogCard *card);
        void handleMqttMessage(char *topic, char *payload);
        void publishADCs();
        void setADCsPublishInterval(uint32_t interval);
        void setADCsPublishEnabled(bool enabled);
    private:
        char *adc_topic;
        char *dac_topic;
        uint32_t adc_publish_interval = 1000;
        uint32_t last_adc_publish = 0;
        bool adc_publish_enabled = false;
        AnalogCard *card;
};